unit uEditarFVectR;

{$MODE Delphi}

interface

uses
{$IFDEF FPC-LCL}
  LResources,
{$ENDIF}

{$IFDEF WINDOWS}
Windows,
{$ENDIF}
 Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Grids, xmatdefs, uFuncionesReales,
  uBaseEditores, utilidades,
  uconstantesSimSEE, uOpcionesSimSEEEdit,
  uExcelFile, uExcelExportImport;

type
  TEditarFVectR = class(TBaseEditores)
    LCurvaVP: TLabel;
    LNDisc: TLabel;
    sgCurva: TStringGrid;
    ENDisc: TEdit;
    BGuardar: TButton;
    BCancelar: TButton;
    BImportarDesdeExcel: TButton;
    BExportarAExcel: TButton;
    procedure EditEnter(Sender: TObject);
    procedure EditTamTablaExit(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: boolean);
    procedure BGuardarClick(Sender: TObject); override;
    procedure FormCreate(Sender: TObject);
    procedure BExportarAExcelClick(Sender: TObject);
    procedure BImportarDesdeExcelClick(Sender: TObject);
  private
    diffX: NReal;
    xmin: NReal;
    xmax: NReal;
    curva: TFVectR;
    xls: TExcelFile;
  protected
    function validarFormulario: boolean; override;
  public
    constructor Create_CrearCurva(AOwner: TForm; capa: integer; xmin, xmax: NReal;
      nPuntosDiscIni: integer; ejeX, ejeY: string); reintroduce; overload;
    constructor Create(AOwner: TForm; xmin, xmax: NReal; f: TFVectR;
      ejeX, ejeY: string); reintroduce; overload;
    function darCurva: TFVectR;
    procedure Free; virtual;
  end;


implementation

uses Math;
  {$R *.lfm}

constructor TEditarFVectR.Create_crearCurva(AOwner: TForm; capa: integer; xmin, xmax: NReal;
  nPuntosDiscIni: integer; ejeX, ejeY: string);
var
  i: integer;
  yval: TDAOfNReal;
begin
  setlength( yval, NPuntosDiscIni );
  curva := TFVectR.Create( capa, yval, xmin, xmax);
  inherited Create(AOwner, curva, nil );
  self.Top := AOwner.Top + plusTop;
  self.Left := AOwner.Left + plusLeft;
  self.xmin := xmin;
  self.xmax := xmax;
  diffX := (xmax - xmin) / (nPuntosDiscIni - 1);
//  curva := nil;
  ENDisc.Text := IntToStr(nPuntosDiscIni);
  sgCurva.RowCount := nPuntosDiscIni + 1;
  sgCurva.Cells[0, 0] := ejeX;
  sgCurva.Cells[1, 0] := ejeY;
  self.Caption := 'Editar funcin - ' + ejeY + ' en funcin de ' + ejeX;
  for i := 1 to nPuntosDiscIni do
  begin
    sgCurva.Cells[0, i] := FloatToStrF(xmin + (i - 1) * diffX, ffFixed, 8, 3);
    sgCurva.Cells[1, i] := '0';
  end;
end;

constructor TEditarFVectR.Create(AOwner: TForm; xmin, xmax: NReal;
  f: TFVectR; ejeX, ejeY: string);
var
  i: integer;
begin
  curva := f.Create_Clone as TFVectR;
  inherited Create(AOwner, f, nil );
  self.Top := AOwner.Top + plusTop;
  self.Left := AOwner.Left + plusLeft;
  self.xmin := xmin;
  self.xmax := xmax;
  diffX := (xmax - xmin) / (f.vector.n - 1);
  ENDisc.Text := IntToStr(f.vector.n);
  sgCurva.RowCount := f.vector.n + 1;
  sgCurva.Cells[0, 0] := ejeX;
  sgCurva.Cells[1, 0] := ejeY;
  self.Caption := 'Editar funcin - ' + ejeY + ' en funcin de ' + ejeX;
  for i := 1 to f.vector.n do
  begin
    sgCurva.Cells[0, i] := FloatToStrF(xmin + (i - 1) * diffX, ffFixed, 8, 3);
    sgCurva.Cells[1, i] := FloatToStr(f.vector.e(i));
  end;
end;

function TEditarFVectR.darCurva: TFVectR;
begin
  Result := curva.Create_Clone as TFVectR;
end;

procedure TEditarFVectR.Free;
begin
  if curva <> nil then curva.Free;
  inherited Free;
end;

function TEditarFVectR.validarFormulario: boolean;
begin
  Result := validarEditInt(ENDisc, 2, MAXINT) and validarTablaNReals_(sgCurva);
end;

procedure TEditarFVectR.EditEnter(Sender: TObject);
begin
  inherited EditEnter(Sender);
end;

procedure TEditarFVectR.EditTamTablaExit(Sender: TObject);
var
  nAnt, n, i: integer;
begin
  if validarEditInt(TEdit(Sender), 2, MAXINT) then
  begin
    nAnt := sgCurva.RowCount - 1;
    n := StrToInt(TEdit(Sender).Text);
    if n <> nAnt then
    begin
      diffX := (xmax - xmin) / (n - 1);
      sgCurva.RowCount := n + 1;
      n := min(n, nAnt);
      for i := 1 to n do
      begin
        sgCurva.Cells[0, i] := FloatToStrF(xmin + (i - 1) * diffX, ffFixed, 8, 3);
      end;
      if n <> 0 then
        for i := n + 1 to sgCurva.RowCount - 1 do
        begin
          sgCurva.Cells[0, i] := FloatToStrF(xmin + (i - 1) * diffX, ffFixed, 8, 3);
          sgCurva.Cells[1, i] := sgCurva.Cells[1, n];
        end
      else
        for i := 1 to sgCurva.RowCount - 1 do
        begin
          sgCurva.Cells[0, i] := FloatToStrF(xmin + (i - 1) * diffX, ffFixed, 8, 3);
          sgCurva.Cells[1, i] := '0';
        end;

      guardado := False;
{      utilidades.AutoSizeCol(sgCurvaVP, 0);
      utilidades.AutoSizeCol(sgCurvaVP, 1);}
      utilidades.AutoSizeTable(self, sgCurva, maxAnchoTablaEnorme,
        maxAlturaTablaEnorme, TSimSEEEditOptions.getInstance.
        deshabilitarScrollHorizontalEnListados);
    end;
  end;
end;

procedure TEditarFVectR.FormCloseQuery(Sender: TObject; var CanClose: boolean);
begin
  inherited FormCloseQuery(Sender, CanClose);
  if CanClose and (xls <> nil) then
    xls.Free;
end;

procedure TEditarFVectR.BExportarAExcelClick(Sender: TObject);
begin
  uExcelExportImport.exportarTablaAExcel_2(xls, sgCurva, BImportarDesdeExcel, nil);
end;

procedure TEditarFVectR.BGuardarClick(Sender: TObject);
var
  i: integer;
  yval: TDAOfNReal;
begin
  if validarFormulario then
  begin
    SetLength( yval, sgCurva.RowCount - 1);
    for i := 1 to sgCurva.RowCount - 1 do
      yval[i - 1] := StrToFloat(sgCurva.Cells[1, i]);
    curva.inicializar( yval, self.xmin, self.xmax );
    ModalResult := mrOk;
  end;
end;

procedure TEditarFVectR.BImportarDesdeExcelClick(Sender: TObject);
begin
  uExcelExportImport.importarTablaDesdeExcel_2(xls, sgCurva,
    BImportarDesdeExcel, nil, True, False);
end;

procedure TEditarFVectR.FormCreate(Sender: TObject);
begin
  guardado := True;
  utilidades.AutoSizeCol(sgCurva, 0);
  utilidades.AutoSizeCol(sgCurva, 1);
  utilidades.AutoSizeTable(self, sgCurva, maxAnchoTablaEnorme,
    maxAlturaTablaEnorme, TSimSEEEditOptions.getInstance.
    deshabilitarScrollHorizontalEnListados);
end;

initialization
end.
