unit uAltaEdicionTPostOper_cambioPasoDeTiempo;

{$IFDEF FPC}
  {$MODE Delphi}
{$ENDIF}

interface

uses
{$IFDEF FPC-LCL}
  LResources,
{$ENDIF}

{$IFDEF WINDOWS}
Windows,
{$ENDIF}
 Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, xMatDefs, uHistoVarsOps,
  uBaseAltaEdicionPostOpers, uLectorSimRes3Defs, uVerDoc,
  uPostOpers, ExtCtrls;

type
  TAltaEdicionTPostOper_cambioPasoDeTiempo = class(TBaseAltaEdicionPostOpers)
    lResultado: TLabel;
    lCronVar: TLabel;
    lHorasPasoNuevo: TLabel;
    cbRes: TComboBox;
    cbParam1: TComboBox;
    BAyuda: TButton;
    eHorasPasoNuevo: TEdit;
    cbPromediar: TCheckBox;
    Label1: TLabel;
    Panel1: TPanel;
    bGuardar: TButton;
    bCancelar: TButton;
    procedure BAyudaClick(Sender: TObject);
    procedure EditEnter(Sender: TObject);
    procedure EditFloatExit(Sender: TObject);
    procedure bCancelarClick(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure BGuardarClick(Sender: TObject); override;
    procedure CBCronVarResultadoChange(Sender: TObject);
    procedure CBCronVarCronVarChange(Sender: TObject);
  protected
    function validarFormulario: boolean; override;
  public
    Constructor Create(AOwner: TComponent; lector: TLectorSimRes3Defs; postOper: TPostOper; tipoPostOper: TClaseDePostOper); override;
  end;

implementation
{$IFNDEF FPC-LCL}
  {$R *.dfm}
{$ELSE}
  {$R *.lfm}
{$ENDIF}

procedure TAltaEdicionTPostOper_cambioPasoDeTiempo.CBCronVarCronVarChange(
  Sender: TObject);
begin
  inherited cbCronVarComplementarioChange(Sender, cbRes, True);
end;

procedure TAltaEdicionTPostOper_cambioPasoDeTiempo.CBCronVarResultadoChange(
  Sender: TObject);
begin
  inherited cbCronVarComplementarioChange(Sender, cbParam1, True);
end;

Constructor TAltaEdicionTPostOper_cambioPasoDeTiempo.Create(AOwner: TComponent; lector: TLectorSimRes3Defs; postOper: TPostOper; tipoPostOper: TClaseDePostOper);
begin
  inherited Create(AOwner, lector, postOper, tipoPostOper);

  inicializarCBCronVars(cbRes, false);
  inicializarCBCronVars(cbParam1, false);

  if postOper <> NIL then
  begin
    setCBCronVar(cbRes, TPostOper_cambioPasoDeTiempo(postOper).res);
    setCBCronVar(cbParam1, TPostOper_cambioPasoDeTiempo(postOper).param1);
    eHorasPasoNuevo.Text:= FloatToStrF(TPostOper_cambioPasoDeTiempo(postOper).horasPasoNuevo, ffGeneral, 16, 10);
    cbPromediar.Checked:= TPostOper_cambioPasoDeTiempo(postOper).promediar;
  end;
end;

function TAltaEdicionTPostOper_cambioPasoDeTiempo.validarFormulario: boolean;
begin
  result:= validarCBCronVars(cbRes) and
           validarCBCronVars(cbParam1) and
           validarEditFloat(eHorasPasoNuevo, 0.01, MaxNReal);
end;

procedure TAltaEdicionTPostOper_cambioPasoDeTiempo.BAyudaClick(Sender: TObject);
begin
  verdoc(Self, TPostOper_cambioPasoDeTiempo);
end;

procedure TAltaEdicionTPostOper_cambioPasoDeTiempo.bCancelarClick(
  Sender: TObject);
begin
  inherited bCancelarClick(Sender);
end;

procedure TAltaEdicionTPostOper_cambioPasoDeTiempo.bGuardarClick(
  Sender: TObject);
begin
  if validarFormulario then
  begin
    if postOper = NIL then
    begin
      postOper:= TPostOper_cambioPasoDeTiempo.Create(valorCBCronVar(cbRes),
                                                     valorCBCronVar(cbParam1),
                                                     StrToFloat(eHorasPasoNuevo.Text),
                                                     cbPromediar.Checked);
    end
    else
    begin
      TPostOper_cambioPasoDeTiempo(postOper).res:= valorCBCronVar(cbRes);
      TPostOper_cambioPasoDeTiempo(postOper).param1:= valorCBCronVar(cbParam1);
      TPostOper_cambioPasoDeTiempo(postOper).horasPasoNuevo:= StrToFloat(eHorasPasoNuevo.Text);
      TPostOper_cambioPasoDeTiempo(postOper).promediar:= cbPromediar.Checked;
    end;
    ModalResult:= mrOk;
  end;
end;

procedure TAltaEdicionTPostOper_cambioPasoDeTiempo.EditEnter(Sender: TObject);
begin
  inherited EditEnter(Sender);
end;

procedure TAltaEdicionTPostOper_cambioPasoDeTiempo.EditFloatExit(
  Sender: TObject);
begin
  inherited EditFloatExit(Sender, 0.01, MaxNReal);
end;

procedure TAltaEdicionTPostOper_cambioPasoDeTiempo.FormCloseQuery(
  Sender: TObject; var CanClose: Boolean);
begin
  inherited FormCloseQuery(Sender, CanClose);
end;

initialization
end.
