unit uExcelFile;

{$IFDEF FPC}
  {$MODE Delphi}
{$ENDIF}

interface

uses
  SysUtils;


type
  TColor = -$7FFFFFFF - 1..$7FFFFFFF;

{$IFDEF WINDOWS}
const
  dllexcel = 'dllexcel.dll';

type
  TExcelFile = class
  public
    function fila: integer;
    function columna: integer;
    function columnaBuffereada: integer;

    constructor Create(nombreHoja1: string; Visible: boolean;
      autocierre, avisocierre: boolean);
    procedure Guardar(nombre: string);
    procedure Abrir(nombArchivo: string);
    procedure agregoLibro;
    procedure agregoHoja(nombreHoja: string);
    procedure EscribirCeldaTexto(nombreHoja: string; fila: integer;
      columna: integer; contenido: string);

    procedure Cerrar(conAviso: boolean);
    procedure Free;
    procedure VisibleOn;
    procedure VisibleOff;

    // agregado por comodidad.
    procedure ActivoHoja_nombre(nombreHoja: string);
    procedure ActivoHoja_numero(numeroHoja: integer);
    procedure ir(fila, columna: integer);
    procedure irr(dfila, dcolumna: integer);

    function ReadV_Str: shortstring;
    function ReadV_Float: extended;
    function ReadV_Int: integer;

    function ReadStr(fila, columna: integer): shortstring;
    function ReadFloat(fila, columna: integer): extended;
    function ReadInt(fila, columna: integer): integer;

    procedure readln;
    procedure go(NombreHoja: string; fila, columna: integer);
    (*.............................................................*)

    //Retorna la letra de la columna nroCol
    function nroColToExcelCol(nroCol: cardinal): string;

    procedure Write(val: shortString); overload;
    procedure Write(val: extended); overload;
    procedure Write(val: integer); overload;

    procedure Write(fila, coluna: integer; val: shortString); overload;
    procedure Write(fila, coluna: integer; val: extended); overload;
    procedure Write(fila, coluna: integer; val: integer); overload;


    procedure WriteF(contenido: shortstring; formato: shortstring); overload;
    procedure WriteF(contenido: extended; formato: shortstring); overload;
    procedure WriteF(contenido: integer; formato: shortstring); overload;
    procedure WriteMAF(contenido: shortstring; celdas: integer;
      alineacion: integer; formato: shortstring); overload;
    procedure WriteMAF(contenido: extended; celdas: integer;
      alineacion: integer; formato: shortstring); overload;
    procedure WriteMAF(contenido: integer; celdas: integer;
      alineacion: integer; formato: shortstring); overload;

    procedure writeln(val: shortstring); overload;
    procedure writeln(val: double); overload;
    procedure writeln(val: integer); overload;
    procedure writeln; overload;

    procedure Write_buffereado(val: shortString); overload;
    procedure Write_buffereado(val: double); overload;
    procedure Write_buffereado(val: integer); overload;

    procedure writelnBuffer; overload;

    function ref(fila, columna: integer): string;
    function ref_rango(f1, c1, f2, c2: integer): string;
    procedure SelRango(fil1, col1, fil2, col2: integer);
    procedure BordeSimple(ancho: integer;
      Arriba, Derecha, Abajo, Izquierda,
      InteriorVertical, InteriorHorizontal: boolean);

    procedure CambiarFuente(nuevafuente: string);
    procedure CambiarTamFuente(nuevotam: integer);

    // cambio de color usando ColorIndex
    procedure CambiarColorFuente_ci(nuevoci: integer);
    procedure CambiarColorFondo_ci(nuevoci: integer);

    // cambio de color usuando un TColor
    procedure CambiarColorFuente_cl(nuevoCol: TColor);
    procedure CambiarColorFondo_cl(nuevoCol: TColor);

    procedure CambiarFormato(nuevoFormato: string);
    procedure CambiarAncho(nuevoAncho: integer);
    procedure CambiarAlto(nuevoAlto: integer);
    procedure CambiarFormula(nuevaFormula: string);
    procedure CombinarCeldas;

    procedure autoFitCells;
    procedure AlinearDerecha;
    procedure AlinearIzquierda;
    procedure AlinearCentro;
    procedure WrapTextON;
    procedure WrapTextOFF;
    procedure BoldON;
    procedure BoldOFF;
    procedure InsertarImagen(archi: string; x, y: integer);
    procedure Zoom(porciento: integer);

    // acomada para imprimir
    procedure SetPage(PaginaVertical: boolean);
    //Retorna true si el libro del TExcelFile esta abierto.
    //Si se cerro el EXCEL sin liberar el TExcelFile retorna false
    function libroAbierto: boolean;

    function contarFilasHastaBlanco: integer;
    function contarColumnasHastaBlanco: integer;

    //12 = office 2007
    function version: double;




  (* complicadas
      function Hoja( numeroHoja: integer ): Variant; overload;
      function Hoja( nombreHoja: string ): Variant; overload;
      procedure EscribirCeldaHojaActual(fila:integer; columna:integer; contenido:variant);
      procedure EscribirCelda(nombreHoja:string; fila:integer; columna:integer; contenido:variant);
      function ContenidoCelda(nombreHoja:string; var fila:integer; columna:integer; incrementa:boolean): variant;
      procedure Write( contenido: variant );
      //cambia el tamanio del buffer

      procedure setTamanioBuffer(nCeldas: Integer);
      //Almacena los datos que se piden escribir en un buffer, los datos no se
      //bajan al excel hasta que se haga un llamado a WriteLnBuffer o el buffer
      //se llena. No usar en combinacion con otros writes. Esto es entre que se
      //hace una llamada WriteBuffereado y su correspondiente llamada a WriteLnBuffer
      //no debe llamarse otro write o se perdera el orden de las columnas
      procedure WriteBuffereado(const contenido: variant );
      procedure WriteLnBuffer;
      function columnaBuffereada: Integer;
      procedure WriteV( contenido: variant );
      //Escribe una fila entera de valores
      procedure WriteFila(const contenido: TDAOfVariant);
      procedure WriteLnFila(const contenido: TDAOfVariant);
      procedure WriteF( contenido: variant; formato: string );
      procedure WriteMAF( contenido: variant; celdas: integer; alineacion: integer; formato: string );
      procedure writeln( contenido: variant ); overload; // fila:=fila+1; columna:= 1
      function getPaletaColores: TPaletaColoresExcel;
      procedure setPaletaColores(nuevaPaleta: TPaletaColoresExcel);
      *)
  end;

procedure xf_aplicarPropiedadesAGrafico(nombreHoja: shortstring;
  tipoGrafico: integer;
  titulo, ejeY: shortstring;
  minEjeYAuto, maxEjeYAuto: boolean;
  minEjeY, MaxEjeY: double;
  minEjeX, MaxEjeX: double); external dllexcel;

procedure xf_aplicarPropiedadesASerie(nombreHoja: shortstring;
  iSerie: integer; //1..nSeries
  tipoGraficoPrincipal, tipoGrafico: integer;
  eje: integer;
  color: TColor); external dllexcel;

function xf_graficar(nombreHoja: shortstring;
  colIni, colFin, filaIni, filaFin: integer): shortstring;
  external dllexcel;


// forma el string de formato numrico
function xf_formatoStr(ndecimales: integer): shortstring;



//QUita caracteres raros del nombre de la hora y lo limita en espacio.
// para evitar lios con Excel.
function PurificarNombreHoja( nombreHoja: String ): string;

{$ENDIF}

implementation

{$IFDEF WINDOWS}
//QUita caracteres raros del nombre de la hora y lo limita en espacio.
function PurificarNombreHoja( nombreHoja: String ): string;
var
  k: integer;
  c: char;
  res: string;
begin
  res:= '';
  for k:= 1 to length( nombreHoja ) do
  begin
    c:= nombreHoja[k];
    case c of
      '0'..'9', 'a'..'z', 'A'..'Z': res:= res + c;
      ' ', '_', '-', '.',':', '$':
        if length( res ) > 0 then
        begin
           if res[length(res)] <> '_' then
              res:= res+'_';
        end;
    end;
  end;

  if  length( res ) > 25 then
    result:= copy( res, 1, 25 )
  else
    result:= res;
end;




procedure xf_alinicio; external dllexcel;
procedure xf_alfinal; external dllexcel;

function xf_fila: integer; external dllexcel;
function xf_columna: integer; external dllexcel;
function xf_columnaBuffereada: integer; external dllexcel;

function xf_Create(nombreHoja1: shortstring; Visible: boolean;
  autocierre, avisocierre: boolean): integer; external dllexcel;
procedure xf_Guardar(nombre: shortstring); external dllexcel;
procedure xf_Abrir(nombArchivo: shortstring); external dllexcel;
procedure xf_agregolibro; external dllexcel;
procedure xf_agregoHoja(nombreHoja: shortstring); external dllexcel;
procedure xf_EscribirCeldaTexto(nombreHoja: shortstring; fila: integer;
  columna: integer; contenido: shortstring); external dllexcel;
procedure xf_Cerrar(conAviso: boolean); external dllexcel;
procedure xf_Free; external dllexcel;
procedure xf_VisibleOn; external dllexcel;
procedure xf_VisibleOff; external dllexcel;
procedure xf_ActivoHoja_nombre(nombreHoja: shortstring); external dllexcel;
procedure xf_ActivoHoja_numero(numeroHoja: integer); external dllexcel;
procedure xf_ir(fila, columna: integer); external dllexcel;
procedure xf_irr(dfila, dcolumna: integer); external dllexcel;

function xf_ReadV_str: shortstring; external dllexcel;
function xf_ReadV_float: extended; external dllexcel;
function xf_ReadV_int: integer; external dllexcel;

procedure xf_readln; external dllexcel;
procedure xf_go(NombreHoja: shortstring; fila, columna: integer); external dllexcel;
function xf_nroColToExcelCol(nroCol: cardinal): shortstring; external dllexcel;

procedure xf_write_str(val: shortstring); external dllexcel;
procedure xf_write_float(val: extended); external dllexcel;
procedure xf_write_int(val: integer); external dllexcel;

procedure xf_WriteF_str(contenido: shortstring; formato: shortstring);
  external dllexcel;
procedure xf_WriteF_float(contenido: extended; formato: shortstring);
  external dllexcel;
procedure xf_WriteF_int(contenido: integer; formato: shortstring); external dllexcel;
procedure xf_WriteMAF_str(contenido: shortstring; celdas: integer;
  alineacion: integer; formato: shortstring); external dllexcel;
procedure xf_WriteMAF_float(contenido: extended; celdas: integer;
  alineacion: integer; formato: shortstring); external dllexcel;
procedure xf_WriteMAF_int(contenido: integer; celdas: integer;
  alineacion: integer; formato: shortstring); external dllexcel;

procedure xf_writeln; external dllexcel;

procedure xf_write_str_buffereado(val: shortstring); external dllexcel;
procedure xf_write_float_buffereado(val: extended); external dllexcel;
procedure xf_write_int_buffereado(val: integer); external dllexcel;

procedure xf_writeln_buffereado; external dllexcel;

function xf_ref(fila, columna: integer): shortstring; external dllexcel;
function xf_ref_rango(f1, c1, f2, c2: integer): shortstring; external dllexcel;
procedure xf_SelRango(fil1, col1, fil2, col2: integer); external dllexcel;
procedure xf_BordeSimple(ancho: integer;
  Arriba, Derecha, Abajo, Izquierda, InteriorVertical, InteriorHorizontal: boolean);
  external dllexcel;
procedure xf_CambiarFuente(nuevafuente: shortstring); external dllexcel;
procedure xf_CambiarTamFuente(nuevotam: integer); external dllexcel;
procedure xf_CambiarColorFuente_ci(nuevoci: integer); external dllexcel;
procedure xf_CambiarColorFondo_ci(nuevoci: integer); external dllexcel;
procedure xf_CambiarColorFuente_cl(nuevoCol: TColor); external dllexcel;
procedure xf_CambiarColorFondo_cl(nuevoCol: TColor); external dllexcel;
procedure xf_CambiarFormato(nuevoFormato: shortstring); external dllexcel;
procedure xf_CambiarAncho(nuevoAncho: integer); external dllexcel;
procedure xf_CambiarAlto(nuevoAlto: integer); external dllexcel;
procedure xf_CambiarFormula(nuevaFormula: shortstring); external dllexcel;
procedure xf_CombinarCeldas; external dllexcel;
procedure xf_AlinearDerecha; external dllexcel;
procedure xf_AlinearIzquierda; external dllexcel;
procedure xf_AlinearCentro; external dllexcel;
procedure xf_WrapTextON; external dllexcel;
procedure xf_WrapTextOFF; external dllexcel;
procedure xf_BoldON; external dllexcel;
procedure xf_BoldOFF; external dllexcel;
procedure xf_InsertarImagen(archi: shortstring; x, y: integer); external dllexcel;
procedure xf_Zoom(porciento: integer); external dllexcel;
procedure xf_SetPage(PaginaVertical: boolean); external dllexcel;
procedure xf_autoFitCells; external dllexcel;
function xf_libroAbierto: boolean; external dllexcel;
function xf_contarFilasHastaBlanco: integer; external dllexcel;
function xf_contarColumnasHastaBlanco: integer; external dllexcel;
function xf_version: double; external dllexcel;


(************ complicadas  *****************
function xf_Hoja_numero( numeroHoja: integer ): Variant;
function xf_Hoja_nombre( nombreHoja: string ): Variant;
procedure xf_EscribirCeldaHojaActual(fila:integer; columna:integer; contenido:variant);
procedure xf_EscribirCelda(nombreHoja:shortstring; fila:integer; columna:integer; contenido:variant);
function xf_ContenidoCelda(nombreHoja:shortstring; var fila:integer; columna:integer; incrementa:boolean): variant;
function xf_ReadV: variant;
procedure xf_Write( contenido: variant );
procedure xf_setTamanioBuffer(nCeldas: Integer);
procedure xf_WriteBuffereado(const contenido: variant );
procedure xf_WriteLnBuffer;
function xf_columnaBuffereada: Integer;
procedure xf_WriteV( contenido: variant );
procedure xf_WriteFila(const contenido: TDAOfVariant);
procedure xf_WriteLnFila(const contenido: TDAOfVariant);
procedure xf_WriteF( contenido: variant; formato: shortstring );
procedure xf_WriteMAF( contenido: variant; celdas: integer; alineacion: integer; formato: shortstring );
procedure xf_writeln( contenido: variant ); overload; // fila:=fila+1; columna:= 1
function xf_getPaletaColores: TPaletaColoresExcel;
procedure xf_setPaletaColores(nuevaPaleta: TPaletaColoresExcel);
*)


// forma el string de formato numrico
function xf_formatoStr(ndecimales: integer): shortstring;
var
  res: string;
  k:   integer;
begin
  if ndecimales <= 0 then
    Result := '0'
  else
  begin
    res := '';
    for k := 1 to ndecimales do
      res  := res + '0';
    res    := '0' + SysUtils.decimalseparator + res;
    Result := res;
  end;
end;

function TExcelFile.fila: integer;
begin
  Result := xf_fila;
end;

function TExcelFile.columna: integer;
begin
  Result := xf_columna;
end;

function TExcelFile.columnaBuffereada: integer;
begin
  Result := xf_columnaBuffereada;
end;

constructor TExcelFile.Create(nombreHoja1: string; Visible: boolean;
  autocierre, avisocierre: boolean);
begin
  xf_Create( PurificarNombreHoja( NombreHoja1 ), Visible, autocierre, avisocierre);
end;

procedure TExcelFile.Guardar(nombre: string);
begin
  xf_Guardar(nombre);
end;

procedure TExcelFile.Abrir(nombArchivo: string);
begin
  xf_Abrir(nombArchivo);
end;

procedure TExcelFile.agregoLibro;
begin
  xf_agregoLibro;
end;

procedure TExcelFile.agregoHoja(nombreHoja: string);
begin

  xf_agregoHoja( PurificarNombreHoja( nombreHoja) );
end;

procedure TExcelFile.EscribirCeldaTexto(nombreHoja: string; fila: integer;
  columna: integer; contenido: string);
begin
  xf_EscribirCeldaTexto( PurificarNombreHoja(nombreHoja ), fila, columna, contenido);
end;

procedure TExcelFile.Cerrar(conAviso: boolean);
begin
  xf_Cerrar(conAviso);
end;

procedure TExcelFile.Free;
begin
  xf_Free;
end;

procedure TExcelFile.VisibleOn;
begin
  xf_VisibleOn;
end;

procedure TExcelFile.VisibleOff;
begin
  xf_VisibleOff;
end;

procedure TExcelFile.ActivoHoja_nombre(nombreHoja: string);
begin
  xf_ActivoHoja_nombre( PurificarNombreHoja( nombreHoja) );
end;

procedure TExcelFile.ActivoHoja_numero(numeroHoja: integer);
begin
  xf_ActivoHoja_numero(numeroHoja);
end;

procedure TExcelFile.ir(fila, columna: integer);
begin
  xf_ir(fila, columna);
end;

procedure TExcelFile.irr(dfila, dcolumna: integer);
begin
  xf_irr(dfila, dcolumna);
end;


function TExcelFile.ReadV_Str: shortstring;
begin
  Result := xf_readv_str;
end;

function TExcelFile.ReadV_Float: extended;
begin
  Result := xf_readv_float;
end;

function TExcelFile.ReadV_Int: integer;
begin
  Result := xf_readv_int;
end;

procedure TExcelFile.readln;
begin
  xf_readln;
end;

function TExcelFile.ReadStr(fila, columna: integer): shortstring;
begin
  ir(fila, columna);
  Result := ReadV_str;
end;

function TExcelFile.ReadFloat(fila, columna: integer): extended;
begin
  ir(fila, columna);
  Result := ReadV_Float;
end;

function TExcelFile.ReadInt(fila, columna: integer): integer;
begin
  ir(fila, columna);
  Result := ReadV_Int;
end;




procedure TExcelFile.go(NombreHoja: string; fila, columna: integer);
begin
  xf_go( PurificarNombreHoja( nombreHoja ), fila, columna);
end;

function TExcelFile.nroColToExcelCol(nroCol: cardinal): string;
begin
  Result := xf_nroColToExcelCol(nroCol);
end;

procedure TExcelFile.Write(val: shortString);
begin
  xf_write_str(val);
end;

procedure TExcelFile.Write(val: extended);
begin
  xf_write_float(val);
end;

procedure TExcelFile.Write(val: integer);
begin
  xf_write_int(val);
end;


procedure TExcelFile.Write(fila, coluna: integer; val: shortString);
begin
  ir(fila, coluna);
  Write(val);
end;

procedure TExcelFile.Write(fila, coluna: integer; val: extended);
begin
  ir(fila, coluna);
  Write(val);
end;

procedure TExcelFile.Write(fila, coluna: integer; val: integer);
begin
  ir(fila, coluna);
  Write(val);
end;


procedure TExcelFile.writeln;
begin
  xf_writeln;
end;

procedure TExcelFile.WriteF(contenido: shortstring; formato: shortstring);
begin
  xf_WriteF_str(contenido, formato);
end;

procedure TExcelFile.WriteF(contenido: extended; formato: shortstring);
begin
  xf_WriteF_float(contenido, formato);
end;

procedure TExcelFile.WriteF(contenido: integer; formato: shortstring);
begin
  xf_WriteF_int(contenido, formato);
end;

procedure TExcelFile.WriteMAF(contenido: shortstring; celdas: integer;
  alineacion: integer; formato: shortstring);
begin
  xf_WriteMAF_str(contenido, celdas, alineacion, formato);
end;

procedure TExcelFile.WriteMAF(contenido: extended; celdas: integer;
  alineacion: integer; formato: shortstring);
begin
  xf_WriteMAF_float(contenido, celdas, alineacion, formato);
end;

procedure TExcelFile.WriteMAF(contenido: integer; celdas: integer;
  alineacion: integer; formato: shortstring);
begin
  xf_WriteMAF_int(contenido, celdas, alineacion, formato);
end;

procedure TExcelFile.Write_buffereado(val: shortString);
begin
  xf_write_str_buffereado(val);
end;

procedure TExcelFile.Write_buffereado(val: double);
begin
  xf_write_float_buffereado(val);
end;

procedure TExcelFile.Write_buffereado(val: integer);
begin
  xf_write_int_buffereado(val);
end;

procedure TExcelFile.writelnBuffer;
begin
  xf_writeln_buffereado;
end;

procedure TExcelFile.writeln(val: shortstring);
begin
  Write(val);
  writeln;
end;

procedure TExcelFile.writeln(val: double);
begin
  Write(val);
  writeln;
end;

procedure TExcelFile.writeln(val: integer);
begin
  Write(val);
  writeln;
end;




function TExcelFile.ref(fila, columna: integer): string;
begin
  Result := xf_ref(fila, columna);
end;

function TExcelFile.ref_rango(f1, c1, f2, c2: integer): string;
begin
  Result := xf_ref_rango(f1, c1, f2, c2);
end;

procedure TExcelFile.SelRango(fil1, col1, fil2, col2: integer);
begin
  xf_selRango(fil1, col1, fil2, col2);
end;

procedure TExcelFile.BordeSimple(ancho: integer;
  Arriba, Derecha, Abajo, Izquierda,
  InteriorVertical, InteriorHorizontal: boolean);
begin
  xf_BordeSimple(ancho, arriba, derecha, abajo, izquierda, InteriorVertical,
    InteriorHorizontal);
end;

procedure TExcelFile.CambiarFuente(nuevafuente: string);
begin
  xf_CambiarFuente(nuevafuente);
end;

procedure TExcelFile.CambiarTamFuente(nuevotam: integer);
begin
  xf_CambiarTamFuente(nuevoTam);
end;

procedure TExcelFile.CambiarColorFuente_ci(nuevoci: integer);
begin
  xf_CambiarColorFuente_ci(nuevoci);
end;

procedure TExcelFile.CambiarColorFondo_ci(nuevoci: integer);
begin
  xf_CambiarColorFondo_ci(nuevoci);
end;

procedure TExcelFile.CambiarColorFuente_cl(nuevoCol: TColor);
begin
  xf_CambiarColorFuente_cl(nuevoCol);
end;

procedure TExcelFile.CambiarColorFondo_cl(nuevoCol: TColor);
begin
  xf_CambiarColorFondo_cl(nuevoCol);
end;

procedure TExcelFile.CambiarFormato(nuevoFormato: string);
begin
  xf_CambiarFormato(nuevoFormato);
end;

procedure TExcelFile.CambiarAncho(nuevoAncho: integer);
begin
  xf_CambiarAncho(nuevoAncho);
end;

procedure TExcelFile.CambiarAlto(nuevoAlto: integer);
begin
  xf_CambiarAlto(nuevoAlto);
end;

procedure TExcelFile.CambiarFormula(nuevaFormula: string);
begin
  xf_CambiarFormula(nuevaFormula);
end;

procedure TExcelFile.CombinarCeldas;
begin
  xf_CombinarCeldas;
end;

procedure TExcelFile.AlinearDerecha;
begin
  xf_AlinearDerecha;
end;

procedure TExcelFile.AlinearIzquierda;
begin
  xf_AlinearIzquierda;
end;

procedure TExcelFile.autoFitCells;
begin
  xf_autoFitCells;
end;

procedure TExcelFile.AlinearCentro;
begin
  xf_AlinearCentro;
end;

procedure TExcelFile.WrapTextON;
begin
  xf_WrapTextOn;
end;

procedure TExcelFile.WrapTextOFF;
begin
  xf_WrapTextOff;
end;

procedure TExcelFile.BoldON;
begin
  xf_BoldOn;
end;

procedure TExcelFile.BoldOFF;
begin
  xf_BoldOff;
end;

procedure TExcelFile.InsertarImagen(archi: string; x, y: integer);
begin
  xf_InsertarImagen(archi, x, y);
end;

procedure TExcelFile.Zoom(porciento: integer);
begin
  xf_Zoom(porciento);
end;

procedure TExcelFile.SetPage(PaginaVertical: boolean);
begin
  xf_SetPage(PaginaVertical);
end;

function TExcelFile.libroAbierto: boolean;
begin
  Result := xf_LibroAbierto;
end;

function TExcelFile.contarFilasHastaBlanco: integer;
begin
  Result := xf_contarFilasHastaBlanco;
end;

function TExcelFile.contarColumnasHastaBlanco: integer;
begin
  Result := xf_contarColumnasHastaBlanco;
end;

function TExcelFile.version: double;
begin
  Result := Version;
end;

initialization
  xf_AlInicio;

finalization
  xf_AlFinal;
{$ENDIF}
end.

