   unit uPrintCronVars;

{$IFDEF FPC}
  {$MODE Delphi}
{$ENDIF}


{$IFNDEF WINDOWS}
// ATENCION ESTO ES HASTA QUE ENCUENTRE LA MANERA
// DE GENERAR ALGO EN LINUX
{$DEFINE SIMRES3SOLOTEXTO}
{$ENDIF}

interface
uses
{$IFNDEF SIMRES3SOLOTEXTO}
 Graphics,
 uExcelFile,  dialogs,
 {$ENDIF}
  uHistoVarsOps, uPrint, xMatDefs, uAuxiliares, SysUtils,
  Classes;


{$IFDEF SIMRES3SOLOTEXTO}
type
  TExcelFile = pointer; // solo para que compile
{$ENDIF}



type
  TClaseDePrintCronVar = class of TPrintCronVar;
  TPrintCronVar = class
    public
      nombreHoja: string;
      titulo, unidades: string;
      digitos, decimales: integer;

      //Retorna false si los parametros no son correctos. En caso de error
      //se agrega una línea por error en errores con la descripcion del problema
      //encontrado
      //Se llama antes de llamar a imprimirse y luego de haber calculado las
      //cronOpers y postOpers
      procedure checkParams(errores: TStringList); virtual;

      procedure imprimirse(xls: TExcelFile); virtual; abstract;
{$IFNDEF SIMRES3SOLOTEXTO}
      procedure imprimirseYCopiarAWord(xls: TExcelFile;
                                       wordApp: Variant); virtual; abstract;
{$ENDIF}
      class function tipo: String; virtual; abstract;

      function getNombresCronVars: String; virtual; abstract;
      function referenciaCronVar(cronVar: TCronVar): boolean; virtual; abstract;
      function parametrosAdicionales: String; virtual;
{$IFNDEF SIMRES3SOLOTEXTO}
      //Retorna la lista de colores que se hayan seleccionado especificamente para
      //su grafico
      function getColores: TDAOfTColor; virtual;
{$ENDIF}
      function serialize: string; virtual;

      function cronVarsAImprimir: TDAOfCronVar; virtual; abstract;
  end;

  TPrintCronVar_UniCronVar = class(TPrintCronVar)
    public
      cronVar: TCronVar;
      function getNombresCronVars: String; override;
      function referenciaCronVar(cronVar: TCronVar): boolean; override;
      function serialize: string; override;

      function cronVarsAImprimir: TDAOfCronVar; override;
  end;

  TPrintCronVar_MultiCronVar = class(TPrintCronVar)
    public
      cronVars: TDAOfCronVar;
      function getNombresCronVars: String; override;
      function referenciaCronVar(cronVar: TCronVar): boolean; override;
      procedure Free;
//      function serialize: string; override;

      function cronVarsAImprimir: TDAOfCronVar; override;
  end;

{$IFNDEF SIMRES3SOLOTEXTO}
  TPrintCronVar_matrizDeDatos = class(TPrintCronVar_UniCronVar)
    private
      //Si no se definieron títulos para todas las columnas agrega las columnas
      //que faltan con título CrónicaN con N el número de columna
      function titulosColsExt: TDAofString;
    public
      Print_promedio: boolean;
      titulosCols: TDAofString;
      chart_Mat: boolean;
      minEjeYAuto, maxEjeYAuto: boolean;
      minEjeY, MaxEjeY: NReal;

      Constructor Create(cronVar: TCronVar;
                         nombreHoja: string;
                         titulo, unidades: string;
                         titulosCols: TDAofString;
                         digitos, decimales: integer;
                         Print_promedio: boolean;
                         chart_Mat: boolean;
                         minEjeYAuto, maxEjeYAuto: boolean;
                         minEjeY, MaxEjeY: NReal);

      procedure imprimirse(xls: TExcelFile); override;
      class function tipo: String; override;
      procedure Free;
      function parametrosAdicionales: String; override;
      function serialize: string; override;

  end;


  TPrintCronVar_histograma = class(TPrintCronVar_UniCronVar)
    public
      chart_Mat: boolean;
      minEjeYAuto, maxEjeYAuto: boolean;
      minEjeY, MaxEjeY: NReal;
      Print_Todas: boolean;
      Print_promedio: boolean;
      Pre_Ordenar: boolean;
      Print_probAisladas: TDAofNReal;
      TipoImpresion_PE: boolean;

      Constructor Create(cronVar: TCronVar;
                         nombreHoja: string;
                         titulo, unidades: string;
                         digitos, decimales: integer;
                         Print_Todas: boolean;
                         Print_promedio: boolean;
                         Pre_Ordenar: boolean;
                         TipoImpresion_PE: boolean;
                         Print_probAisladas: TDAofNReal;
                         chart_Mat: boolean;
                         minEjeYAuto, maxEjeYAuto: boolean;
                         minEjeY, MaxEjeY: NReal);
      procedure imprimirse(xls: TExcelFile); override;
(*
      procedure imprimirseYCopiarAWord(xls: TExcelFile;
                                       wordApp: Variant); override;
*)
      class function tipo: String; override;
      procedure Free;
      function parametrosAdicionales: String; override;
      class function printProbAisladasPorDefecto: TDAofNReal;
      function serialize: string; override;
  end;

{$ENDIF}


  TPrintCronVar_histograma_text = class(TPrintCronVar_UniCronVar)
    public
      Print_Todas: boolean;
      Print_promedio: boolean;
      Pre_Ordenar: boolean;
      TipoImpresion_PE: boolean;
      Print_probAisladas: TDAofNReal;
      Constructor Create(cronVar: TCronVar;
                         archi: string;
                         titulo, unidades: string;
                         digitos, decimales: integer;
                         Print_Todas: boolean;
                         Print_promedio: boolean;
                         Pre_Ordenar: boolean;
                         TipoImpresion_PE: boolean;
                         Print_probAisladas: TDAofNReal );
      procedure imprimirse(xls: TExcelFile); override;
      class function tipo: String; override;
      procedure Free;
      function parametrosAdicionales: String; override;
      class function printProbAisladasPorDefecto: TDAofNReal;
      function serialize: string; override;
  end;

{$IFNDEF SIMRES3SOLOTEXTO}
  TPrintCronVar_HistogramaGlobal= class(TPrintCronVar_UniCronVar)
    public
      minX, maxX: NReal;
      nPuntosHistograma: Integer;

      Constructor Create(cronVar: TCronVar;
                         nombreHoja: string;
                         titulo, unidades: string;
                         digitos, decimales: integer;
                         minX, maxX: NReal; nPuntosHistograma: Integer{;
                         chart_Mat: boolean;
                         minEjeYAuto, maxEjeYAuto: boolean;
                         minEjeY, MaxEjeY: NReal});
      procedure imprimirse(xls: TExcelFile); override;
      procedure imprimirseYCopiarAWord(xls: TExcelFile;
                                       wordApp: Variant); override;
      class function tipo: String; override;
      procedure Free;
      function serialize: string; override;
  end;

  TPrintCronVar_compararValoresMultiplesCronVars = class(TPrintCronVar_MultiCronVar)
    public
      tipoValorAComparar: TTipoValoresAComparar;
      //Solo aplica si el tipoValorAComparar = ProbabilidadesDeExcedencia
      probExcedencia: NReal;

      Pre_Ordenar: boolean;
      ProbExcedencia_Sup: NReal; // borde superior

      graficar: boolean;
      minEjeYAuto, maxEjeYAuto: boolean;
      minEjeY, MaxEjeY: NReal;

      tiposGraficos: TDAOfTTipoGrafico;
      ejes: TDAOfTTipoEje;
      //clDefault hace que elija automático
      colores: TDAOfTColor;

      Constructor Create(cronVars: TDAOfCronVar;
                         nombreHoja: string;
                         titulo, unidades: string;
                         digitos, decimales: integer;
                         tipoValorAComparar: TTipoValoresAComparar;
                         probExcedencia: NReal;
                         Pre_Ordenar: boolean;
                         ProbExcedencia_Sup: NReal;
                         graficar: boolean;
                         tiposGraficos: TDAOfTTipoGrafico;
                         ejes: TDAOfTTipoEje;
                         //clDefault hace que elija automático
                         colores: TDAOfTColor;
                         minEjeYAuto, maxEjeYAuto: boolean;
                         minEjeY, MaxEjeY: NReal);

      procedure checkParams(errores: TStringList); override;
      procedure imprimirse(xls: TExcelFile); override;
      procedure imprimirseYCopiarAWord(xls: TExcelFile;
                                       wordApp: Variant); override;
      class function tipo: String; override;
      procedure Free;
      function parametrosAdicionales: String; override;
      function getColores: TDAOfTColor; override;
      function serialize: string; override;
  end;
{$ENDIF}


implementation
uses
  uAuxiliaresEscrituraSimRes;
  
//------------------------
//Métodos de TPrintCronVar
//========================

procedure TPrintCronVar.checkParams(errores: TStringList);
begin
  //Nada
end;

function TPrintCronVar.parametrosAdicionales: String;
begin
  result:= '-';
end;

{$IFNDEF SIMRES3SOLOTEXTO}
function TPrintCronVar.getColores: TDAOfTColor;
begin
  result:= NIL;
end;
{$ENDIF}

function TPrintCronVar.serialize: string;
begin
  result:= tipo;
end;

//----------------------------------
//Métodos de TPrintCronVarUniCronVar
//==================================

function TPrintCronVar_UniCronVar.getNombresCronVars: String;
begin
  result:= cronVar.nombre;
end;

function TPrintCronVar_UniCronVar.referenciaCronVar(cronVar: TCronVar): boolean;
begin
  result:= self.cronVar = cronVar;
end;

function TPrintCronVar_UniCronVar.serialize: String;
begin
  result:= inherited serialize + #9 +  encomille(cronVar.nombre);
end;

function TPrintCronVar_UniCronVar.cronVarsAImprimir: TDAOfCronVar;
var
  res: TDAOfCronVar;
begin
  SetLength(res, 1);
  res[0] := cronVar;
  result := res;
end;

//------------------------------------
//Métodos de TPrintCronVarMultiCronVar
//====================================

function TPrintCronVar_MultiCronVar.getNombresCronVars: String;
var
  res: String;
  i: Integer;
begin
  if Length(cronVars) > 0 then
  begin
    res:= cronVars[0].nombre;
    for i:= 1 to high(cronVars) do
      res:= res + ', ' + cronVars[i].nombre;
  end
  else
    res:= '';
  result:= res;
end;

function TPrintCronVar_MultiCronVar.referenciaCronVar(cronVar: TCronVar): boolean;
var
  referencia: boolean;
  i: Integer;
begin
  referencia:= False;
  for i:= 0 to high(cronVars) do
    if cronVars[i] = cronVar then
    begin
      referencia:= true;
      break;
    end;
  result:= referencia;
end;

procedure TPrintCronVar_MultiCronVar.Free;
begin
  SetLength(cronVars, 0);
  inherited Free;
end;

function TPrintCronVar_MultiCronVar.cronVarsAImprimir: TDAOfCronVar;
begin
  result := cronVars;
end;

//--------------------------------------
//Métodos de TPrintCronVar_matrizDeDatos
//======================================

{$IFNDEF SIMRES3SOLOTEXTO}
Constructor TPrintCronVar_matrizDeDatos.Create(cronVar: TCronVar;
                                               nombreHoja: string;
                                               titulo, unidades: string;
                                               titulosCols: TDAofString;
                                               digitos, decimales: integer;
                                               Print_promedio: boolean;
                                               chart_Mat: boolean;
                                               minEjeYAuto, maxEjeYAuto: boolean;
                                               minEjeY, MaxEjeY: NReal);
begin
  inherited Create;
  self.cronVar:= cronVar;
  self.nombreHoja:= nombreHoja;
  self.titulo:= titulo;
  self.unidades:= unidades;
  self.titulosCols:= titulosCols;
  self.digitos:= digitos;
  self.decimales:= decimales;
  self.Print_promedio:= Print_promedio;
  self.chart_Mat:= chart_Mat;
  self.minEjeYAuto:= minEjeYAuto;
  self.maxEjeYAuto:= maxEjeYAuto;
  self.minEjeY:= minEjeY;
  self.MaxEjeY:= MaxEjeY;
end;

procedure TPrintCronVar_matrizDeDatos.imprimirse(xls: TExcelFile);
begin
  WriteMatToXLS_SinOrdenar(
    xls, nombreHoja, cronVar.v,
    titulo, unidades, titulosColsExt,
    cronVar.nPasos,
    cronVar.nCronicas,
    cronVar.dtIni,
    cronVar.DurPaso_horas / 24,
    decimales,
    Print_promedio, chart_Mat,
    minEjeYAuto, maxEjeYAuto, minEjeY, MaxEjeY);
end;

(*
procedure TPrintCronVar_matrizDeDatos.imprimirseYCopiarAWord(xls: TExcelFile;
                                                             wordApp: Variant);
begin
  WriteMatToXLSAndCopyToWord_SinOrdenar(xls, nombreHoja, cronVar.v, titulo, unidades, titulosColsExt, cronVar.nPasos,
                                        cronVar.nCronicas, cronVar.dtIni, cronVar.DurPaso_horas / 24, digitos, decimales,
                                        Print_promedio, chart_Mat,
                                        minEjeYAuto, maxEjeYAuto, minEjeY, MaxEjeY,
                                        wordApp);
end;

*)

class function TPrintCronVar_matrizDeDatos.tipo: String;
begin
  result:= 'matrizDeDatos';
end;

procedure TPrintCronVar_matrizDeDatos.Free;
begin
  SetLength(titulosCols, 0);
  inherited Free;
end;

function TPrintCronVar_matrizDeDatos.parametrosAdicionales: String;
begin
  result:= 'Imprimir Promedio= ' + boolToSiNo(Print_promedio) + ', Graficar= ' + boolToSiNo(chart_Mat);
end;

function TPrintCronVar_matrizDeDatos.titulosColsExt: TDAofString;
var
  i: Integer;
  res: TDAofString;
  n: integer;
  s: String;
begin
  if cronVar.nCronicas = Length(titulosCols) then
    res:= titulosCols
  else
  begin
    n:= length( titulosCols );
    SetLength(res, cronVar.nCronicas);

    if ( n > cronVar.nCronicas )then
    begin
      s:= 'Error, en TPrintCronVar_matrizDeDatos. '#13#10+
      'De la cronVar: '+cronVar.nombre+ #13#10+
      'Especificó más titulos de columnas que la cantidad columnas de la matriz.'#13#10+
      ' Se ignoran los títulos: '#13#10;
      for i:= cronVar.nCronicas to high( titulosCols ) do
        s:= s+', '+titulosCols[i];
      showmessage( s );

      n:= cronVar.nCronicas;
    end;

    for i:= 0 to n-1 do
      res[i]:= titulosCols[i];
    for i:= n to high(res) do
      res[i]:= 'Cron_' + IntToStr(i + 1);
  end;
  result:= res;
end;

function TPrintCronVar_matrizDeDatos.serialize: string;
begin
  result:= inherited serialize + #9 +
          encomille(nombreHoja) + #9 +
          encomille(titulo) + #9 +
          encomille(unidades) + #9 +
          TDAOfStringToStringConTamanio(titulosCols) + #9 +
          IntToStr(digitos) + #9 +
          IntToStr(decimales) + #9 +
          BoolToStr(Print_promedio, true) + #9 +
          BoolToStr(chart_Mat, true) + #9 +
          BoolToStr(minEjeYAuto, true) + #9 +
          BoolToStr(maxEjeYAuto, true) + #9 +
          FloatToStrF(minEjeY, ffGeneral, 8, 3) + #9 +
          FloatToStrF(MaxEjeY, ffGeneral, 8, 3);
end;

//-----------------------------------
//Métodos de TPrintCronVar_histograma
//===================================

Constructor TPrintCronVar_histograma.Create(cronVar: TCronVar;
                                            nombreHoja: string;
                                            titulo, unidades: string;
                                            digitos, decimales: integer;
                                            Print_Todas: boolean;
                                            Print_promedio: boolean;
                                            Pre_Ordenar: boolean;
                                            TipoImpresion_PE: boolean;
                                            Print_probAisladas: TDAofNReal;
                                            chart_Mat: boolean;
                                            minEjeYAuto, maxEjeYAuto: boolean;
                                            minEjeY, MaxEjeY: NReal);
begin
  inherited Create;
  self.cronVar:= cronVar;
  self.nombreHoja:= nombreHoja;
  self.titulo:= titulo;
  self.unidades:= unidades;
  self.digitos:= digitos;
  self.decimales:= decimales;
  self.Print_Todas:= Print_Todas;
  self.Print_promedio:= Print_promedio;
  self.Pre_Ordenar:= Pre_Ordenar;
  self.TipoImpresion_PE:= TipoImpresion_PE;
  self.Print_probAisladas:= Print_probAisladas;
  self.chart_Mat:= chart_Mat;
  self.minEjeYAuto:= minEjeYAuto;
  self.maxEjeYAuto:= maxEjeYAuto;
  self.minEjeY:= minEjeY;
  self.MaxEjeY:= MaxEjeY;
end;

procedure TPrintCronVar_histograma.imprimirse(xls: TExcelFile);
begin
  WriteMatToXLS(
    xls, nombreHoja, cronVar.v, UTF8TOAnsi(titulo), unidades, cronVar.nPasos,
    cronVar.nCronicas, cronVar.dtIni, cronVar.DurPaso_horas / 24.0,
    decimales,
    Print_Todas, Print_promedio,
    Pre_Ordenar,
    TipoImpresion_PE,
    Print_probAisladas, chart_Mat,
    minEjeYAuto, maxEjeYAuto, minEjeY, MaxEjeY);
end;

(*
procedure TPrintCronVar_Histograma.imprimirseYCopiarAWord(xls: TExcelFile;
                                                          wordApp: Variant);
begin
  WriteMatToXLSAndCopyToWord(xls, nombreHoja, cronVar.v, titulo, unidades, cronVar.nPasos,
                cronVar.nCronicas, cronVar.dtIni, cronVar.DurPaso_horas / 24.0, digitos, decimales,
                Print_Todas, Print_promedio, Print_probAisladas, chart_Mat,
                minEjeYAuto, maxEjeYAuto, minEjeY, MaxEjeY, wordApp);
end;
  *)


class function TPrintCronVar_Histograma.tipo: String;
begin
  result:= 'histograma';
end;

function TPrintCronVar_Histograma.parametrosAdicionales: String;
begin
  if length(Print_probAisladas) > 0 then
    result:= 'Imprimir Promedio= ' + boolToSiNo(Print_promedio) + ', Graficar= ' + boolToSiNo(chart_Mat) + ', PrintProbsAisladas= ' + TDAOfNRealToStringSinTamanio(Print_probAisladas, 4, 3, ', ')
  else
    result:= 'Imprimir Promedio= ' + boolToSiNo(Print_promedio) + ', Graficar= ' + boolToSiNo(chart_Mat) + ', PrintProbsAisladas= no';
end;

class function TPrintCronVar_Histograma.printProbAisladasPorDefecto: TDAofNReal;
var
  printProbsAisladasPorDefecto: TDAofNReal;
begin
  SetLength(printProbsAisladasPorDefecto, 4);
  printProbsAisladasPorDefecto[0]:= 0.1;
  printProbsAisladasPorDefecto[1]:= 0.3;
  printProbsAisladasPorDefecto[2]:= 0.7;
  printProbsAisladasPorDefecto[3]:= 0.9;
  Result:= printProbsAisladasPorDefecto;
end;

procedure TPrintCronVar_Histograma.Free;
begin
  SetLength(Print_probAisladas, 0);
  inherited Free;
end;


function TPrintCronVar_Histograma.serialize: string;
begin
   result:= inherited serialize + #9 +
          encomille(nombreHoja) + #9 +
          encomille(titulo) + #9 +
          encomille(unidades) + #9 +
          IntToStr(digitos) + #9 +
          IntToStr(decimales) + #9 +
          BoolToStr(Print_Todas, true) + #9 +
          BoolToStr(Print_promedio, true) + #9 +
          BoolToStr(Pre_Ordenar, true) + #9 +
          BoolToStr(TipoImpresion_PE, true) + #9 +
          TDAOfNRealToTabbedStringConTamanio(Print_probAisladas, 8, 3) + #9 +
          BoolToStr(chart_Mat, true) + #9 +
          BoolToStr(minEjeYAuto, true) + #9 +
          BoolToStr(maxEjeYAuto, true) + #9 +
          FloatToStrF(minEjeY, ffGeneral, 8, 3) + #9 +
          FloatToStrF(MaxEjeY, ffGeneral, 8, 3);
end;

{$ENDIF}


//-----------------------------------
//Métodos de TPrintCronVar_histograma_text
//===================================

Constructor TPrintCronVar_histograma_text.Create(cronVar: TCronVar;
                   archi: string;
                   titulo, unidades: string;
                   digitos, decimales: integer;
                   Print_Todas: boolean;
                   Print_promedio: boolean;
                   Pre_Ordenar: boolean;
                   TipoImpresion_PE: boolean;
                   Print_probAisladas: TDAofNReal );
begin
  inherited Create;
  self.cronVar:= cronVar;
  if pos( '.', archi ) = 0 then archi:= archi + '.xlt';
  self.nombreHoja:= archi;
  self.titulo:= titulo;
  self.unidades:= unidades;
  self.digitos:= digitos;
  self.decimales:= decimales;
  Self.Print_Todas:= Print_Todas;
  Self.Print_promedio:= Print_Promedio;
  Self.Pre_Ordenar:= Pre_Ordenar;
  Self.TipoImpresion_PE:= TipoImpresion_PE;
  Self.Print_probAisladas:= Print_probAisladas;
end;

procedure TPrintCronVar_histograma_text.imprimirse(xls: TExcelFile);
begin
  WriteMatToText(
    nombreHoja,
    cronVar.v, UTF8ToAnsi( titulo ), cronVar.nPasos,
    cronVar.nCronicas, cronVar.dtIni, cronVar.DurPaso_horas / 24.0,
    digitos,
    decimales,
    Print_Todas, Print_promedio, Pre_Ordenar, TipoImpresion_PE, Print_probAisladas );
end;

class function TPrintCronVar_histograma_text.tipo: String;
begin
  result:= 'histograma_text';
end;

procedure TPrintCronVar_histograma_text.Free;
begin
  SetLength(Print_probAisladas, 0);
  inherited Free;
end;

function TPrintCronVar_histograma_text.parametrosAdicionales: String;
begin
  if length(Print_probAisladas) > 0 then
    result:= 'Imprimir Promedio= ' + boolToSiNo(Print_promedio) + ', PrintProbsAisladas= ' + TDAOfNRealToStringSinTamanio(Print_probAisladas, 4, 3, ', ')
  else
    result:= 'Imprimir Promedio= ' + boolToSiNo(Print_promedio) + ', PrintProbsAisladas= no';
end;

class function TPrintCronVar_histograma_text.printProbAisladasPorDefecto: TDAofNReal;
var
  printProbsAisladasPorDefecto: TDAofNReal;
begin
  SetLength(printProbsAisladasPorDefecto, 4);
  printProbsAisladasPorDefecto[0]:= 0.1;
  printProbsAisladasPorDefecto[1]:= 0.3;
  printProbsAisladasPorDefecto[2]:= 0.7;
  printProbsAisladasPorDefecto[3]:= 0.9;
  Result:= printProbsAisladasPorDefecto;
end;


function TPrintCronVar_Histograma_text.serialize: string;
begin
   result:= inherited serialize + #9 +
          encomille(nombreHoja) + #9 +
          encomille(titulo) + #9 +
          encomille(unidades) + #9 +
          IntToStr(digitos) + #9 +
          IntToStr(decimales) + #9 +
          BoolToStr(Print_Todas, true) + #9 +
          BoolToStr(Print_promedio, true) + #9 +
          BoolToStr(Pre_Ordenar, true) + #9 +
          BoolToStr(TipoImpresion_PE, true) + #9 +
          TDAOfNRealToTabbedStringConTamanio(Print_probAisladas, 8, 3);
end;

{$IFNDEF SIMRES3SOLOTEXTO}

(** métodos de TPrintCronVar_HistogramaGlobal **)
Constructor TPrintCronVar_HistogramaGlobal.Create(cronVar: TCronVar;
                                                  nombreHoja: string;
                                                  titulo, unidades: string;
                                                  digitos, decimales: integer;
                                                  minX, maxX: NReal; nPuntosHistograma: Integer{;
                                                  chart_Mat: boolean;
                                                  minEjeYAuto, maxEjeYAuto: boolean;
                                                  minEjeY, MaxEjeY: NReal});
begin
  inherited Create;
  self.cronVar:= cronVar;
  self.nombreHoja:= nombreHoja;
  self.titulo:= titulo;
  self.unidades:= unidades;
  self.digitos:= digitos;
  self.decimales:= decimales;
  self.minX:= minX;
  self.maxX:= maxX;
  self.nPuntosHistograma:= nPuntosHistograma
{  self.chart_Mat:= chart_Mat;
  self.minEjeYAuto:= minEjeYAuto;
  self.maxEjeYAuto:= maxEjeYAuto;
  self.minEjeY:= minEjeY;
  self.MaxEjeY:= MaxEjeY;}
end;

procedure TPrintCronVar_HistogramaGlobal.imprimirse(xls: TExcelFile);
begin
  writeHistogramaGlobalToXls(xls, nombreHoja, cronVar.v, UTF8ToAnsi(titulo), unidades,
                            decimales, minX, maxX, nPuntosHistograma
                             {, chart_Mat, minEjeYAuto,
                             maxEjeYAuto, minEjeY, MaxEjeY});
end;

procedure TPrintCronVar_HistogramaGlobal.imprimirseYCopiarAWord(xls: TExcelFile;
                                                                wordApp: Variant);
begin
  raise Exception.Create('TPrintCronVar_HistogramaGlobal.imprimirseYCopiarAWord: sin implementar')
end;

class function TPrintCronVar_HistogramaGlobal.tipo: String;
begin
  result:= 'HistogramaGlobal';
end;

procedure TPrintCronVar_HistogramaGlobal.Free;
begin
  inherited Free;
end;

function TPrintCronVar_HistogramaGlobal.serialize: String;
begin
  result:= inherited serialize + #9 +
          encomille(nombreHoja) + #9 +
          encomille(titulo) + #9 +
          encomille(unidades) + #9 +
          IntToStr(digitos) + #9 +
          IntToStr(decimales) + #9 +
          FloatToStr(minX) + #9 +
          FloatToStr(maxX) + #9 +
          IntToStr(nPuntosHistograma);
end;


//---------------------------------------------------------
//Métodos de TPrintCronVar_compararValoresMultiplesCronVars

//=========================================================

Constructor TPrintCronVar_compararValoresMultiplesCronVars.Create(cronVars: TDAOfCronVar;
                                                             nombreHoja: string;
                                                             titulo, unidades: string;
                                                             digitos, decimales: integer;
                                                             tipoValorAComparar: TTipoValoresAComparar;
                                                             probExcedencia: NReal;
                                                             Pre_Ordenar: boolean;
                                                             ProbExcedencia_Sup: NReal; // borde superior
                                                             graficar: boolean;
                                                             tiposGraficos: TDAOfTTipoGrafico;
                                                             ejes: TDAOfTTipoEje;
                                                             //clDefault hace que elija automático
                                                             colores: TDAOfTColor;
                                                             minEjeYAuto, maxEjeYAuto: boolean;
                                                             minEjeY, MaxEjeY: NReal);
begin
  inherited Create;
  self.cronVars:= cronVars;
  self.nombreHoja:= nombreHoja;
  self.titulo:= titulo;
  self.unidades:= unidades;
  self.digitos:= digitos;
  self.decimales:= decimales;
  self.tipoValorAComparar:= tipoValorAComparar;
  self.probExcedencia:= probExcedencia;

  self.Pre_Ordenar:= Pre_Ordenar;
  self.ProbExcedencia_Sup:= ProbExcedencia_Sup; // borde superior

  self.graficar:= graficar;
  self.tiposGraficos:= tiposGraficos;
  self.ejes:= ejes;
  self.colores:= colores;
  self.minEjeYAuto:= minEjeYAuto;
  self.maxEjeYAuto:= maxEjeYAuto;
  self.minEjeY:= minEjeY;
  self.MaxEjeY:= MaxEjeY;
end;

procedure TPrintCronVar_compararValoresMultiplesCronVars.checkParams(errores: TStringList);
var
  i, nf, nc: Integer;
begin
  nf:= length(cronVars[0].v);
  nc:= Length(cronVars[0].v[0]);

  for i:= 0 to high(cronVars) do
    if cronVars[i].v = NIL then
    begin
      errores.Add('La cronVar "' + cronVars[i].nombre + '" no ha sido inicializada.' +
                  ' Asegurese de que "' + cronVars[i].nombre + '" sea el resultado de al menos una cronOper o una postOper.');
//      break;
    end
    else if (length(cronVars[i].v) <> nf) or (Length(cronVars[i].v[0]) <> nc) then
    begin
      errores.Add('La cronVar "' + cronVars[i].nombre + '" tiene distinta dimensión que la cronVar "' + cronVars[0].nombre + '".' +
                  ' Para poder imprimir debe seleccionar un conjunto de cronVars con la misma dimensión.');
//      break;
    end;
end;

procedure TPrintCronVar_compararValoresMultiplesCronVars.imprimirse(xls: TExcelFile);
var
  nombres: TDAofString;
  mats: array of TMatOfNReal;
  i: Integer;
begin
  SetLength(mats, length(cronVars));
  SetLength(nombres, length(cronVars));

  for i:= 0 to high(cronVars) do
  begin
    nombres[i]:= Utf8ToAnsi(cronVars[i].nombre );
    mats[i]:= cronVars[i].v;
  end;

  WriteValoresToXLS(
    xls, tipoValorAComparar,
    probExcedencia, Pre_Ordenar,
    ProbExcedencia_Sup,

                    nombres, mats, Utf8ToAnsi( nombreHoja ), Utf8ToAnsi( titulo ) , unidades,
                    cronVars[0].dtIni, cronVars[0].DurPaso_horas / 24.0,
                    decimales,
                    graficar, tiposGraficos, ejes, colores,
                    minEjeYAuto, maxEjeYAuto, minEjeY, MaxEjeY);

  SetLength(nombres, 0);
  SetLength(mats, 0);
end;

procedure TPrintCronVar_compararValoresMultiplesCronVars.imprimirseYCopiarAWord(xls: TExcelFile;
                                                                           wordApp: Variant);
begin
  raise Exception.Create('TPrintCronVar_compararValoresMultiplesCronVars.imprimirseYCopiarAWord: sin implementar');
end;

class function TPrintCronVar_compararValoresMultiplesCronVars.tipo: String;
begin
  result:= 'CompararValoresMultiplesCronVars'
end;

procedure TPrintCronVar_compararValoresMultiplesCronVars.Free;
begin
  inherited Free;
end;

function TPrintCronVar_compararValoresMultiplesCronVars.parametrosAdicionales: String;
var
  res: String;
begin
  if tipoValorAComparar = ProbabilidadesDeExcedencia then
    res:= 'Valores a Comparar= P.E. ' + FloatToStr(probExcedencia) + '[p.u], '
  else
    res:= 'Valores a Comparar= ' + TTipoValoresACompararToString(tipoValorAComparar) + ', ';

  if graficar then
  begin
    res:= res + 'Graficar= si';
  end
  else
    res:= res + 'Graficar= no';
  Result:= res;
end;

function TPrintCronVar_compararValoresMultiplesCronVars.getColores: TDAOfTColor;
var
  i, nColoresNoDefault: Integer;
  res: TDAOfTColor;
begin
  nColoresNoDefault:= 0;
  SetLength(res, length(colores));
  for i:= 0 to high(colores) do
    if colores[i] <> colorAutomatico then
    begin
      res[nColoresNoDefault]:= colores[i];
      nColoresNoDefault:= nColoresNoDefault + 1;
    end;

  if nColoresNoDefault <> Length(res) then
    SetLength(res, nColoresNoDefault);
  result:= res;
end;

function TPrintCronVar_compararValoresMultiplesCronVars.serialize: String;
begin
   result:= inherited serialize +#9 +
          TDAOfCronVarTipoGraficoEjeColorToStringConTamanio(cronVars,
                                                            tiposGraficos,
                                                            ejes,
                                                            colores) + #9 +
          encomille(nombreHoja) + #9 +
          encomille(titulo) + #9 +
          encomille(unidades) + #9 +
          IntToStr(digitos) + #9 +
          IntToStr(decimales) + #9 +
          encomille(TTipoValoresACompararToString(tipoValorAComparar)) + #9 +
          FloatToStr(probExcedencia) + #9 +

          BoolToStr(Pre_Ordenar) + #9 +
          FloatToStr(ProbExcedencia_Sup) + #9 +

          BoolToStr(graficar, true) + #9 +
          BoolToStr(minEjeYAuto, true) + #9 +
          BoolToStr(maxEjeYAuto, true) + #9 +
          FloatToStrF(minEjeY, ffGeneral, 8, 3) + #9 +
          FloatToStrF(MaxEjeY, ffGeneral, 8, 3);
end;
{$ENDIF}

end.
